/*
	A basic extension of the java.awt.Dialog class
 */

import java.awt.*;

public class AboutDialog extends Dialog {

	public AboutDialog(Frame parent, boolean modal)
	{
		super(parent, modal);

		setLayout(null);
		setSize(303,168);
		setVisible(false);
		
		setTitle("Voice Games - About");
		
		label1.setText("Voice Games");
		label1.setAlignment(java.awt.Label.CENTER);
		add(label1);
		label1.setBounds(36,12,240,24);
		
		label3.setText("Copyright 2001 (c) Takeo Igarashi");
		label3.setAlignment(java.awt.Label.CENTER);
		add(label3);
		label3.setBounds(36,60,240,24);
		
		label4.setText("http://www.mtl.t.u-tokyo.ac.jp/~takeo");
		label4.setAlignment(java.awt.Label.CENTER);
		add(label4);
		label4.setBounds(36,84, 240,24);
		
		okButton.setLabel("OK");
		add(okButton);
		okButton.setBounds(120,120,66,27);
        

		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		okButton.addActionListener(lSymAction);

	}
    
	public void addNotify()
	{
		Dimension d = getSize();

		super.addNotify();

		// Only do this once.
		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		Insets insets = getInsets();
		setSize(insets.left + insets.right + d.width, insets.top + insets.bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(insets.left, insets.top);
			components[i].setLocation(p);
		}

		// Used for addNotify check.
		fComponentsAdjusted = true;
	}
	

	java.awt.Button okButton = new java.awt.Button();
	java.awt.Label label1 = new java.awt.Label();
	java.awt.Label label3 = new java.awt.Label();
	java.awt.Label label4 = new java.awt.Label();

	// Used for addNotify check.
	boolean fComponentsAdjusted = false;

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == okButton)
				okButton_ActionPerformed(event);
		}
	}
	void okButton_ActionPerformed(java.awt.event.ActionEvent event)
	{
		this.dispose();
	}
	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == AboutDialog.this)
				AboutDialog_WindowClosing(event);
		}
	}
	void AboutDialog_WindowClosing(java.awt.event.WindowEvent event)
	{
		this.dispose();
	}
}
