import java.awt.event.*;
import java.awt.*;
import java.applet.*;
import java.lang.Math.*;
import java.util.*;


class TitlePanel extends Panel {

	
	Frame frame;
	TitlePanel(Frame frame){
		this.frame = frame;
		
		MouseDispatcher mouseDispatcher = new MouseDispatcher();
		addMouseListener(mouseDispatcher);
		addMouseMotionListener(mouseDispatcher);
		
		images = new Images(this);
		prepare_boxes();
		prepare_panels();
		manual = new Manual();
	}
	Images images;
	
	
	
	

	
	
	
	
	Manual manual;
	public void manual(){
		manual.show();
		manual.setLocation(73, 74);
	}
	public void about(){
		AboutDialog aboutDialog = new AboutDialog( frame, true );
		Point p = frame.getLocation();
		aboutDialog.setLocation(p.x+145, p.y+157);
		aboutDialog.setVisible( true );
	}
	
	
	
	
	
	
	
	
	jump.JumpPanel jumpPanel;
	swim.SwimPanel swimPanel;
	punch.PunchPanel punchPanel;
	
	public void prepare_panels(){
		jumpPanel = new jump.JumpPanel();
		swimPanel = new swim.SwimPanel();
		punchPanel = new punch.PunchPanel();
		
		currentPanel = this;
	}
	public void home(){
		switchPanel(this);
	}
	Panel currentPanel;
	public void start_jump(){
		switchPanel(jumpPanel);

		jumpPanel.init();
		jumpPanel.start();
		jumpPanel.repaint();
		
	}
	public void start_swim(){
		switchPanel(swimPanel);
		swimPanel.init();
		swimPanel.start();
		swimPanel.repaint();
	}
	public void start_punch(){
		switchPanel(punchPanel);
		punchPanel.start();
	}
	public void switchPanel(Panel panel){
		if (currentPanel == panel)
			return;
		if (currentPanel == swimPanel)
			((swim.SwimPanel)currentPanel).end();
		else if (currentPanel == punchPanel)
			((punch.PunchPanel)currentPanel).end();
		
		frame.remove(currentPanel);
		
		frame.add("Center", panel);
		
		frame.invalidate();
		frame.doLayout();		
		
		currentPanel = panel;
	}
	
	
	
	
	
	
	
	
	
	

	Image buffered_image = null;

	public void update(Graphics g) {
		paint(g);
	}
	public void paint(Graphics g) {
		if (images.loading){
			images.loadImage(g);
			return;
		}

		//double buffering
		if (buffered_image == null)
			buffered_image = createImage(getSize().width, getSize().height);
		Graphics bg = buffered_image.getGraphics();

		// clear
		bg.clearRect(0,0, getSize().width, getSize().height);

		// paint code!
		bg.drawImage(images.title, 0,-10, null);
		paintBox(bg);

		//double buffering
		bg.dispose();
      
		g.drawImage(buffered_image,0,0,this);

	}


	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	Rectangle[] boxes;
	Rectangle box;
	public void prepare_boxes(){
		boxes = new Rectangle[3];
		boxes[0] = new Rectangle(10,  118, 177, 248);
		boxes[1] = new Rectangle(190, 118, 224, 248);
		boxes[2] = new Rectangle(421,  118, 206, 248);
	}
	public void paintBox(Graphics g){
		if (box == null)
			return;
		g.setColor(Color.red);
		//g.draw3DRect(box.x, box.y, box.width, box.height, true);	
		g.drawRoundRect(box.x, box.y, box.width, box.height,10,10);	
	}
	public void activateBox(Point p){
		Rectangle prev_box = box;
		box = null;
		for(int i=0; i<3; i++){
			if (boxes[i].contains(p)){
				box = boxes[i];
			}
		}
		if (box != prev_box)
			repaint();
	}
	public void clickBox(Point p){
		if (boxes[0].contains(p))
			start_jump();
		else if (boxes[1].contains(p))
			start_swim();
		else if (boxes[2].contains(p))
			start_punch();
		
	}
	
	
	
	
	
	
   
   
   
	// central event dispatcher
	public class MouseDispatcher 
		extends MouseAdapter implements MouseMotionListener{

  		public void mouseMoved(MouseEvent e) {
	    	e.consume();
			activateBox(e.getPoint());
  		}
  		public void mouseDragged(MouseEvent e) {
	    	e.consume();
   		}
  		public void mousePressed(MouseEvent e) {
	 	    e.consume();
			clickBox(e.getPoint());
		}
		public void mouseReleased(MouseEvent e) {
			e.consume();
		}
    }
}







