package jump;

import java.applet.Applet;
import java.applet.AudioClip;
import java.awt.*;

public class JumpPanel extends Applet implements Runnable {
    AudioClip ah,bubble,whoopy,boink;
    Image enemy1, enemy2;
    Image mascot, cloud, zaurus, rezard, loo, wombat;
    int current;
    int turn;
    int zaurus_x, zaurus2_x, zaurus3_x, rezard_x;
    Thread thread;
    int height;
    int score, life, game_on, hi_score;

    HeightLevel height_level;
    boolean mouse_is_pressed;
    boolean ascending;
    
    int  ground = 380;//290;

    public void init() {
        
        game_on = 0;
        reset();



        mascot = Toolkit.getDefaultToolkit().getImage( "images\\mascot.gif");
        cloud = Toolkit.getDefaultToolkit().getImage( "images\\cloud.gif");
        zaurus = Toolkit.getDefaultToolkit().getImage( "images\\zaurus.gif");
        rezard = Toolkit.getDefaultToolkit().getImage( "images\\rezard.gif");
        loo = Toolkit.getDefaultToolkit().getImage( "images\\loo.gif");
        wombat = Toolkit.getDefaultToolkit().getImage( "images\\wombat.gif");
 
        setBackground(new Color(0, 255, 255));
        setForeground(new Color(255, 0, 0));
        setFont(new Font("Helvetica", Font.PLAIN, 24));

    }

    public void reset() {
        life = 180;
        score = 0;
        zaurus_x = 0;
        zaurus2_x = -320;
        zaurus3_x = -900;
        rezard_x = -80;
        current =0;
        height = ground;
        height_level = new HeightLevel();
        ascending = false;
        mouse_is_pressed = false;

        enemy1 = zaurus;
        enemy2 = rezard;
    }

    public void start() {
        if (thread == null) {
            thread = new Thread(this);
            thread.start();
        }
    }

    public void stop() {
        if (thread != null) {
            thread.stop();
            thread = null;
        }
    }



   public void update(Graphics g) {
	paint(g);
   }

   Image buffered_image;
   Graphics bg;

    public void paint(Graphics g) {
 	if (buffered_image == null)
	    buffered_image = createImage(getSize().width, getSize().height);

	bg = buffered_image.getGraphics();   
	bg.setColor(new Color(0, 255, 255));
	bg.fillRect(0,0, getSize().width, getSize().height);
	bg.setColor(new Color(0, 128, 0));
	bg.fillRect(0,ground-30, getSize().width, getSize().height);
	
    	paint_main(bg);
 
 	bg.dispose();
        g.drawImage(buffered_image,0,0,this);   	
    }
 
    public void paint_main(Graphics g) {
 
		g.setColor(new Color(255, 0,0));
		g.setFont(new Font("Helvetica", Font.PLAIN, 24));
        g.drawString("HI-SCORE:  "+String.valueOf(hi_score), 10, 30);
        g.drawString("SCORE:     "+String.valueOf(score), 360, 30);
        g.drawString("LIFE:   ", 360, 60);
        g.fillRect(440,40,life,20);

        g.drawImage(cloud,  current, 80 , this);

		
		g.setColor(Color.black);
		int r = 30 - (height)*20/100;
		g.fillOval(400+40-r, ground - 6 - r/3, r*2, r*2/3);

        
		g.drawImage(mascot,  400+10, ground - height - 92, this);

        g.drawImage(enemy1,  zaurus_x  , ground - 80 , this);
        g.drawImage(enemy1,  zaurus2_x  , ground - 80 , this);
        g.drawImage(enemy1,  zaurus3_x  , ground - 80 , this);
        g.drawImage(enemy2,  rezard_x  , ground - 40 , this);

        if (game_on == 0) {
			g.setColor(Color.red);
			g.setFont(new Font("Helvetica", Font.PLAIN, 48));
			//g.drawString("GAME OVER", 170, 200);
			g.drawString("CLICK SCREEN", 150, 240);
        }

    }
	
	final int RESOLUTION = 88;//10;
	public double[] spectrum = new double[1000];
	int val;
	public boolean poll(){
		//voice.Voice.poll(spectrum, RESOLUTION);
		
		int n = voice.Voice.update();
		voice.Voice.get_spectrum(spectrum, RESOLUTION, 0);

		val = (int) (spectrum[3]);
		return true;
	}

    public void run() {
    	int t;
        while(true) {
        	
            try {
            	t = (int)(100*Math.pow(0.99, score/100));//100-score/40;
            	if (t<10) t = 10;
                Thread.sleep(t);//300 - score / 20);
            } catch (InterruptedException e) {
                break;
            }

            if (game_on == 1){
            
        	poll();
			mouse_is_pressed = (val > 10);


	    if (ascending) {
	      if (height_level.is_top()){
	      	height_level.descend();
	      	ascending = false;
	      }
	      else if (!mouse_is_pressed){
	        height_level.descend();
	      	ascending = false;
	      }
	      else {
	        height_level.ascend();
	      }
	    }
	    // descending
	    else {  
	      if (height_level.is_bottom()){
	        if (mouse_is_pressed){
		  ascending = true;
		  height_level.ascend();
		  //boink.play();
		}
	      }
	      else {
	        height_level.descend();
	      }
	    }

	    
	    // height = ground - height_level.get_height();	      
	    height = height_level.get_height();	      


            current += 10;
            if (current > 600) current = -150;
			
            zaurus_x += 20;//40
            if (zaurus_x > 600) zaurus_x = -80;
            zaurus2_x += 20;
            if (zaurus2_x > 800) zaurus2_x = -80;
			
			if (score > 700)
				zaurus3_x += 20;
            if (zaurus3_x > 600) zaurus3_x = -80;
			
			if (score > 2000)
				rezard_x += 30;//60
            if (rezard_x > 600) rezard_x = -60;

            score += 10;
            if (life < 180) life += 1;
            turn = turn+1;
            if (turn==3) {
            	//bubble.play();
            	turn = 0;
            }

            if (height <= 60){
              if (((zaurus_x >= 360)&&(zaurus_x <= 440)) //400
                  || ((zaurus2_x >= 360)&&(zaurus2_x <= 440)) 
                  || ((zaurus3_x >= 360)&&(zaurus3_x <= 440))){ 
                life -=  16;
                //ah.play();
              }
            }
            if ((rezard_x >= 360)&&(rezard_x <= 440)
                 &&(height ==0)){
               life -=  20;
               //ah.play();
            }

            if (life < 0)  {
				playwav.PlayWav.play("sounds\\ah.wav");
				
				if (score > hi_score)
					hi_score = score;
				
               game_on = 0;
			   
               mouse_is_pressed = false;
               //ah.stop();
               //bubble.stop();
               //whoopy.play();
               System.gc();
            }
           if (score == 3000){
             enemy1 = loo;
             enemy2 = wombat;
           }
  
            repaint();
	


        }

        }

    }

    public boolean handleEvent(Event e) {
        switch (e.id) {
          case Event.MOUSE_DOWN:
          case Event.KEY_PRESS:
            mouse_is_pressed = true;
            return false;
          case Event.MOUSE_UP:
          case Event.KEY_RELEASE:
            if ((game_on == 0) && (mouse_is_pressed)){
               reset(); game_on = 1;}
            mouse_is_pressed = false;
            return false;
        }
        return false;
    }
}


class HeightLevel {
    public int height;
    public final int max_height = 7;
    public int[] heights = {0, 15, 28, 39, 48, 55, 60, 63, 64};
    public HeightLevel(){
    	height = 0;
    }
    public void ascend(){
    	height++;
    }
    public void descend(){
    	height--;
    }
    public boolean is_top(){
        return (height == max_height);
    }
    public boolean is_bottom(){
        return (height == 0);
    }
    public int get_height(){
    	int i = max_height-height;
    	int h = max_height*max_height - i * i;
    	return h * 2;//2*(heights[height] 
    }

}