package punch;

import java.awt.event.*;
import java.awt.*;
import java.applet.*;



public class Graphics2 {

    public static void drawWideLine(Graphics g, 
		double x1, double y1, double x2, double y2, double w){
			drawWideLine(g, (int)x1,(int)y1,(int)x2,(int)y2,w);
    }
    public static void drawWideLine(Graphics g, Point p0, Point p1, double w){
			drawWideLine(g, p0.x, p0.y, p1.x,p1.y, w);
    }
    public static void drawLine(Graphics g, Point p0, Point p1){
			g.drawLine(p0.x, p0.y, p1.x,p1.y);
    }

	public static void drawWideLine(Graphics g, 
		int x1, int y1, int x2, int y2, double w){

	Polygon s = createPolygon(x1, y1, x2, y2, w);
	g.fillPolygon(s);
	
    }

    public static boolean insideWideLine(Point xy, 
		int x1, int y1, int x2, int y2, double w){

	Polygon s = createPolygon(x1, y1, x2, y2, w);
	return s.contains(xy);
	
    }




    public static Polygon createPolygon( 
		int x1, int y1, int x2, int y2, double w){

	int x = x2 - x1;
	int y = y2 - y1;
	double length = Math.sqrt(x*x + y*y);
	double nx = x / length * w /2.0;
	double ny = y / length * w /2.0;

	Point start = new Point(x1, y1);
	Point end   = new Point(x2, y2);
	Vector2 vector = new Vector2(nx, ny);

	Polygon s = new Polygon();

	addPoint(s, start, Vector2.rotate(vector, 90));
	addPoint(s, start, Vector2.rotate(vector, 135));
	addPoint(s, start, Vector2.rotate(vector, 180));
	addPoint(s, start, Vector2.rotate(vector, 225));
	addPoint(s, start, Vector2.rotate(vector, 270));
	addPoint(s, end, Vector2.rotate(vector, 270));
	addPoint(s, end, Vector2.rotate(vector, 315));
	addPoint(s, end, Vector2.rotate(vector, 0));
	addPoint(s, end, Vector2.rotate(vector, 45));
	addPoint(s, end, Vector2.rotate(vector, 90));
	addPoint(s, start, Vector2.rotate(vector, 90));
	
	return s;
    }

    static void addPoint(Polygon s, Point p, Vector2 v){
	s.addPoint((int)(p.x + v.x), (int)(p.y + v.y));
    }



    /** center.x, center.y, radius, width */
    public static void drawWideCircle(Graphics g, 
		int x, int y, int radius, int w){

	for(int i= radius - w/2; i < radius + w/2; i++)
	  g.drawOval(x-i, y-i, i*2-1, i*2-1);
    }


	
	
	
	public static void drawRect(Graphics g, Rectangle bbox){
		g.drawRect(bbox.x, bbox.y, bbox.width, bbox.height);
	}
	public static void fillRect(Graphics g, Rectangle bbox){
		g.fillRect(bbox.x, bbox.y, bbox.width, bbox.height);
	}
	
	



}

