package punch;

import java.awt.event.*;
import java.awt.*;
import java.applet.*;
import java.lang.Math.*;
import java.util.*;


public class PunchPanel extends Panel {

	public PunchPanel(){
	
		
		
		monster = new Monster((Vector) File.load("images\\monster.dat"));
		monster.setParameters();
		
		star = new Star((Vector) File.load("images\\star.dat"));
		star.setParameters();

		MouseDispatcher mouseDispatcher = new MouseDispatcher();
		addMouseListener(mouseDispatcher);
		
		addComponentListener(
					   new ComponentAdapter(){
						   public void componentResized(ComponentEvent e){
							   resized();};});		
		
		voiceControl = new VoiceControl(this);
		

	}
	VoiceControl voiceControl;
	
	Monster monster;
	Star star;
	
	
	
	int score, hi_score, time;
	boolean game_is_running;
	public void start(){
		target_punch_count = 10;
		punch_count = 0;
		
		score = 0;
		game_is_running = false;

		FollowThread.startFollow(voiceControl);
		timer = new Timer();
		timer.start();				
		
	}
	public void end(){
		FollowThread.stopFollow();
		timer.stop();				
	}
	
	
	
	
	
	
	
	
	
	
	
	


   Image buffered_image = null;

   public void update(Graphics g) {
	paint(g);
   }
   public void paint(Graphics g) {

	//double buffering
	if (buffered_image == null)			
		buffered_image = createImage(getSize().width, getSize().height);
	Graphics bg = buffered_image.getGraphics();

	// clear
	bg.setColor(new Color(128, 255, 255));
	bg.fillRect(0,0, getSize().width, (int)( getSize().height*0.8));
	bg.setColor(new Color(128, 255, 128));
	bg.fillRect(0,(int)(getSize().height*0.8), getSize().width, (int)(getSize().height*0.2));

	
	// paint code!
	
	paint_main(bg);

	//double buffering
	bg.dispose();
      
	g.drawImage(buffered_image,0,0,this);

   }
   Point center;
   public void resized(){
		buffered_image = createImage(getSize().width, getSize().height);
		center = new Point( getSize().width/2, getSize().height*3/5);
	
   }
   
   
	
   
   
   
   
   
	public void paint_main(Graphics g){
		//if (game_is_running)
		paint_picture(g);
		
		
		g.setColor(Color.red);
		g.setFont(new Font("Helvetica", Font.PLAIN, 24));
		
        g.drawString("HI-SCORE:  "+String.valueOf(hi_score), 10, 30);
        g.drawString("SCORE:     "+String.valueOf(score), 400, 30);

		g.drawString("TIME:   ", 10, 60);
        g.fillRect(80,40,time,20);
		

		
		if (!game_is_running){
			g.setColor(Color.red);
			g.setFont(new Font("Helvetica", Font.PLAIN, 48));
			g.drawString("CLICK SCREEN", 150, 240);
		}		
	}
	
	
	public void paint_picture(Graphics g){
		if (count != -1){
			paint_death(g);
			return;
		}
		
		int size = 	(int)(getSize().width*0.5);

		if (punched)
			size = (int) (size * 0.95);
				
		monster.paint(g, new Point(getSize().width/2, getSize().height*3/5), size, 0);
		
		
		for(int i=0; i<target_punch_count; i++){
			star.paint(g, punch_position(i), 40, (i < punch_count) );	
		}
	}
	
	
	
	public void paint_death(Graphics g){

		int x = (int)(getSize().width * (0.5 + 0.5 * count / max_count));
		int y = (int)(getSize().height * (0.6 - 0.5 * count / max_count));
		int size = (int)(0.5* getSize().width * (max_count - count) / max_count);
		monster.paint(g, new Point(x, y), size, 360*(max_count - count) / max_count);
	}	
	
	
	
	
	
	
	
	
	
	
	

	
	
	final int punch_size = 40;
	public void paint_punch(Graphics g, Point center, boolean done){
		if (done){
			g.setColor(Color.yellow);
			g.fillOval(center.x - punch_size/2, center.y - punch_size/2, punch_size, punch_size);
		}
		
		g.setColor(Color.red);
		g.drawOval(center.x - punch_size/2, center.y - punch_size/2, punch_size, punch_size);

	}
	final int radius = 100;
	public Point punch_position(int i){
		double angle = i*360/target_punch_count;
		Vector2 vec = new Vector2(0, -radius);
		vec = Vector2.rotate(vec, angle);
		return new Point(center.x + (int)vec.x, center.y + (int)vec.y);
	}
	
	
	
	int target_punch_count = 10;
	int punch_count = 0;
	public void short_punch(){
		if (!game_is_running) return;
		if (count != -1)	return;
		
		punched = false;

		punch_count++;
		if (punch_count >= target_punch_count)
			monster.color = new Color(255, 128, 128);
		else
			monster.color = Color.white;
		
		repaint();
	}
	
	public void long_punch(){
		if (!game_is_running) return;
		if (count != -1)	return;
		//if (!ready) return;

		if (punch_count >= target_punch_count){
			play_sound(monster_count);
			
			score += time*10;
			monster_count++;
			next_monster();
		}
		else
			monster.color = Color.white;
		
		repaint();
	}
	public void start_punch(){
		if (!game_is_running) return;
		if (count != -1)	return;

		punched = true;
		//monster.color = new Color(255, 200, 200);
		repaint();
	}
	public void silence(){
		if (!game_is_running) return;
		punched = false;
		if (punch_count >= target_punch_count){
			monster.color = new Color(255, 128, 128);
			ready = true;
		}
		repaint();
	}
	
	public boolean punched = false;
	public boolean ready = false;
	
	
	
	
	
	

	
	
	
	
	int monster_count;
	public void start_game(){
		if (game_is_running)
			return;
		
		monster_count = 0;
		next_monster();
		count = -1;
		//target_punch_count = 10;
		//punch_count = 0;
		
		score = 0;
		
		game_is_running = true;

		
		repaint();
	}
	public void game_over(){
		playwav.PlayWav.play("sounds\\ah.wav");
		
		if (score > hi_score)
			hi_score = score;
		
		game_is_running = false;
		repaint();
	}
	String[] sound_names = {"hidebu.wav", "abesi.wav", "tawaba.wav"};
	public void play_sound(int i){
		int n = i - (i/3)*3;
		playwav.PlayWav.play("sounds\\"+sound_names[n]);	
	}
	
	
	
	public void next_monster(){
		monster.color = Color.white;
		punch_count = 0;
		target_punch_count = 5 + (int)(10.0 * random(monster_count));//Math.random());
		count = 0;
		ready = false;
			
		time = (int)((target_punch_count + 3) * 20 * (Math.pow(0.9, monster_count)*0.8+0.2));
	}
	
	
	
	
	
	
	
	Timer timer;
	int count = -1;
	int max_count = 6;
	public void tick(){
		if (!game_is_running)
			return;
		
		time -= 2;
		if (time <0){
			game_over();
		}
		
		
		if (count >= 0){
			count++;
			if (count == max_count)
				count = -1;
			//repaint();
		}
		
		repaint();
		
	}
	
	
	

	
	long prev_time;
  	public class Timer extends Thread{
	  public void run(){
	    while(true){
	    	prev_time = System.currentTimeMillis();
	      	tick();

              try { Thread.sleep(100);
              } catch (InterruptedException e){}

	    }
	  }
	  public void stop_ifAlive(){
	    if (isAlive()) stop();
	  }
	}
	

	// central event dispatcher
	public class MouseDispatcher 
		extends MouseAdapter {

  		public void mouseClicked(MouseEvent e) {
	    	e.consume();
			start_game();
  		}
    }
	
	
   //long x = 21233456;
	static public double random(int i){
		return (1+noise(i*3+29312))/2;
	}
	// -1..1
   static public double noise(long x){
    x = (x<<13) ^ x;
    return ( 1.0 - ( (x * (x * x * 15731 + 789221) + 1376312589) & 0x7fffffff) / 1073741824.0);    
   }		
   
}







