package punch;
import java.awt.*;
import java.lang.Math.*;
import java.util.*;
import java.io.*;

public class Star
{
	Vector stroke;
	Star(Vector stroke){
		this.stroke = stroke;
	}
	
	public void setParameters(){
		int min_x = -1;
		int min_y = -1;
		int max_x = -1;
		int max_y = -1;
		
		for(int j=0; j<stroke.size(); j++){
				Point p = (Point) stroke.elementAt(j);
				if (min_x == -1 || p.x < min_x) min_x = p.x;
				if (min_y == -1 || p.y < min_y) min_y = p.y;
				if (max_x == -1 || p.x > max_x) max_x = p.x;
				if (max_y == -1 || p.y > max_y) max_y = p.y;
		}
			
		center.x = (min_x + max_x) / 2;
		center.y = (min_y + max_y) / 2;
		size = Math.max(max_x-min_x, max_y-min_y);		
	}
	
	Point center = new Point();
	int size;

	
	
	Point screen_center = new Point();
	int screen_size;	
	public void paint(Graphics g, Point screen_center, int screen_size, boolean fill){
		this.screen_center = screen_center;
		this.screen_size = screen_size;
		
		
		if (fill){
			g.setColor(Color.yellow);
			fillStroke(g, stroke);
		}
		
		g.setColor(Color.red);
		drawStroke(g, stroke);
	}
	
	public void drawStroke(Graphics g, Vector stroke){
		
		for(int i=0; i<stroke.size()-1; i++){
			Point p = convert((Point) stroke.elementAt(i));
			Point q = convert((Point) stroke.elementAt(i+1));
			g.drawLine(p.x, p.y, q.x, q.y);
		}
				
		
	}
	public void fillStroke(Graphics g, Vector stroke){
		
		int nPoints = stroke.size();
		int[] xPoints = new int[nPoints];
		int[] yPoints = new int[nPoints];
		for(int i=0; i<nPoints; i++){
			Point p = convert((Point) stroke.elementAt(i));
			xPoints[i] = p.x;
			yPoints[i] = p.y;
		}
		g.fillPolygon(xPoints, yPoints, nPoints);
	
	}
	public Point convert(Point p){
		return new Point(screen_center.x + (p.x -center.x)  * screen_size / size,
						 screen_center.y + (p.y -center.y) * screen_size / size);
	}	
}
