package punch;
import java.awt.*;

public class Vector2 {
	
	public double x;
	public double y;
	

	Vector2(Point start, Point end){
		x = end.x -  start.x;
		y = end.y -  start.y;
	}
	Vector2(Vertex2D start, Vertex2D end){
		x = end.x -  start.x;
		y = end.y -  start.y;
	}

	Vector2(Point p){
		x = p.x;
		y = p.y;
	}
	Vector2(){
	}
	Vector2(double _x, double _y){
		x = _x;
		y = _y;
	}





    public static Vector2 add(Vector2 u, Vector2 v){
		return new Vector2(u.x + v.x, u.y + v.y);
    }
    public void add(Vector2 v){
	    x += v.x;
	    y += v.y;
   	}
    public static Vector2 subtract(Vector2 u, Vector2 v){
		return new Vector2(u.x - v.x, u.y - v.y);
    }
    public void subtract(Vector2 v){
	    x -= v.x;
	    y -= v.y;
   	}
	public static Vector2 normalize(Vector2 v){
	    double length = v.getLength();
	    if (length == 0) length = 1;
	    return new Vector2(v.x / length, v.y / length);
	}	
	public void normalize(){
	    double length = getLength();
	    if (length == 0) length = 1;
		x = x/length;
		y = y/length;
	}

   	public static Vector2 multiply(Vector2 v, double m){
	    return new Vector2(v.x * m, v.y * m);
   	}
    public void multiply(double m){
	    x *= m;
	    y *= m;
   	}
	
	// rotate 0-360
	public static Vector2 rotate(Vector2 v, double degree){
	    if (degree == 90)
		return new Vector2(-v.y, v.x);
	    else if (degree == 180)
		return new Vector2(-v.x, -v.y);
	    else if (degree == 270)
		return new Vector2(v.y, -v.x);

	    
	    double radian = degree * Math.PI / 180.0;
	    double cos = Math.cos(radian);
	    double sin = Math.sin(radian);

	    return  new Vector2(v.x * cos - v.y * sin,
				v.x * sin + v.y * cos );
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	public double getLength(){
	  return Math.sqrt(x*x + y*y);
	}

	public static double dotProduct(Vector2 u, Vector2 v){
		return u.x * v.x + u.y * v.y;
	}
	public static double crossProduct(Vector2 u, Vector2 v){
		return u.x * v.y - u.y * v.x;
	}

	public static double cos(Vector2 u, Vector2 v){
	  double length = 
	    Math.sqrt( (u.x*u.x + u.y*u.y)*(v.x*v.x + v.y*v.y) );
	  if (length >0)
	    return dotProduct(u, v) / length;
	  else
	    return 0;
	}

	public static double sin(Vector2 u, Vector2 v){
	  double length = 
	    Math.sqrt( (u.x*u.x + u.y*u.y)*(v.x*v.x + v.y*v.y) );
	  if (length >0)
	    return crossProduct(u, v) / length;
	  else
	    return 0;
	}  


	
	
	
	
	
	
	
	// 0-PI
    public static double get_relative_angle(Vector2 u, Vector2 v){
		double cosine = cos(u, v);
		if (cosine <= -1) return Math.PI;
		else if (cosine >= 1) return 0;
		else return Math.acos(cosine);
    }

	// 0-360 
	public static double get_angle360(Vector2 u, Vector2 v){
		double cos = cos(u, v);
		double sin = sin(u, v);
		if (cos == 0)
			if (sin > 0)	return 90;
			else		return 270;
		if (sin == 0)
			if (cos > 0)	return 0;
			else		return 180;
		
		// -PI/2   ...   +PI/2
		double angle = 180 * Math.atan(sin/cos) / Math.PI;

		if (cos < 0)
			angle = angle + 180;
		if (angle < 0)
			angle = angle + 360;
		return angle;
	}
		
	// get angel between -180 ... 180
	public static double get_angle180(Vector2 u, Vector2 v){
		double cos = cos(u,v);
		double sin = sin(u,v);
		if (cos == 0)
			if (sin > 0)	return 90;
			else		return -90;
		if (sin == 0)
			if (cos > 0)	return 0;
			else		return 180;
		
		// -PI/2   ...   +PI/2
		double angle = 180 * Math.atan(sin/cos) / Math.PI;

		if (cos < 0)
			if (angle>0)
				angle -= 180;
			else
				angle +=180;
		return angle;
	}

	
	
	
	
	
	
	
	
	

	public static double distance(int x1, int y1, int x2, int y2){
	  return Math.sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1));
	}
	public static double distance(Point start, Point end){
	  return distance(start.x, start.y, end.x, end.y);
	}
	public static double distance(double x1, double y1, double x2, double y2){
	  return Math.sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1));
	}
	public static Vector2 interporate(Point start, Point end, double t){
	  return new Vector2( start.x * (1-t) + end.x * t, start.y * (1-t) + end.y * t);
	}
	public Point point(){
		return new Point((int)x, (int)y);
	}



	public static Vector2 interporate(Vertex2D start, Vertex2D end, double t){
	  return new Vector2( start.x * (1-t) + end.x * t, start.y * (1-t) + end.y * t);
	}
	public static double distance(Vertex2D start, Vertex2D end){
	  return distance(start.x, start.y, end.x, end.y);
	}


}
