package swim;

import java.awt.event.*;
import java.awt.*;
import java.applet.*;
import java.lang.Math.*;
import java.util.*;

public class SwimPanel extends Panel 
{
	final int RESOLUTION = 256;
	public SwimPanel(){
		MouseDispatcher mouseDispatcher = new MouseDispatcher();
		addMouseListener(mouseDispatcher);
	}
	public void init(){
		images = new Images(this);
	}
	public void imageLoaded(){
		//voice.Voice.start();
		//FollowThread.startFollow(this);		
	}
	
	Images images;
	
	
	
	
	
	
	
	
	public void start(){
		pitch = 0;
		enemy = new Point(600, 200);
		squid = new Point(900, 200);
		speed = 0;
		score = 0;
		life = 3;

		FollowThread.startFollow(this);		
	}
	public void end(){
		FollowThread.stopFollow()	;
	}
	
	
	
	
	
	
   Image buffered_image = null;
	
	public void update(Graphics g) {
		paint(g);
	}
	public void paint(Graphics g) {
		if (images.loading){
			images.loadImage(g);
			return;
		}
	   
		//double buffering
		if (buffered_image == null)
			buffered_image = createImage(getSize().width, getSize().height);
		Graphics bg = buffered_image.getGraphics();

		// clear
		//bg.setColor(new Color(40,80,255));
		//bg.fillRect(0,0, getSize().width, getSize().height);
		int dy = getSize().height/9;
		for(int i=0; i<10; i++){
			double k = (18-i)/18.0;
			bg.setColor(new Color((int)(k*40),(int)(k*80),(int)(k*255)));
			bg.fillRect(0, dy*i, getSize().width, dy);
		}
		
		
		
		// paint code!
		paint_main(bg);

		//double buffering
		bg.dispose();
      
		g.drawImage(buffered_image,0,0,this);

   }
   
	int MIN_PITCH = -30;
	int MAX_PITCH = 70;

	public void paint_main(Graphics g){
		g.setFont(new Font("Helvetica", Font.PLAIN, 24));
		
		int toggle = get_toggle();
		
		int y0 = 40;
		g.drawImage(images.fish[toggle], 10, y0+fish_y, null);
		g.drawImage(images.enemy[toggle], enemy.x, y0+enemy.y, null);
		g.drawImage(images.squid[toggle], squid.x, y0+squid.y, null);
		

		
		g.setColor(Color.red);

        g.drawString("HI-SCORE:  "+String.valueOf(hi_score), 10, 30);
        g.drawString("SCORE:     "+String.valueOf(score), 420, 30);

		if (!game_is_running){
			g.setColor(Color.red);
			g.setFont(new Font("Helvetica", Font.PLAIN, 48));
			g.drawString("CLICK SCREEN", 150, 240);
		}
	}


	int toggle_count = 0;
	private int get_toggle(){
		if (!game_is_running)
			return 0;
		
		int toggle;
		toggle_count++;
		if (toggle_count == 6)
			toggle_count = 0;

		if (toggle_count < 3)
			toggle = 0;
		else
			toggle = 1;
		return toggle;
	}
	
	
	
	
	
	int fish_y;
	Point enemy = new Point(600, 200);
	Point squid = new Point(900, 200);
	int speed = 0;
	int score, hi_score;
	int life = 3;
	boolean game_is_running = false;
	public void game_tick(){
		if (!game_is_running)
			return;
		
		fish_y = 200-pitch*3;

		speed++;
		int step = 15 + speed/200;//20
				  
		enemy.x -= step;
		if (enemy.x < -80){
			enemy.x = this.getSize().width;
			//enemy_y = 130*(int)(3*Math.random());
			enemy.y = fish_y;
		}
		
		if (score > 1000)
		squid.x -= step*1.2;
		if (squid.x < -80){
			squid.x = this.getSize().width;
			squid.y = 20+130*(int)(3*Math.random());

		}
				
		//if (speaking)
		score += 10;
		
		if (touched()){
			playwav.PlayWav.play("sounds\\ah.wav");
				
			if (score > hi_score)
				hi_score = score;
				
			game_is_running = false;
				
		}
		
	}
	public boolean touched(){
		return ((Math.abs((fish_y+29) - (enemy.y+35)) < 64 && Math.abs((10+40)-(enemy.x+60)) < 80)
				|| (Math.abs((fish_y+29) - (squid.y+20)) < 50 && Math.abs((10+40)-(squid.x+60)) < 80));
	}

	
	public void start_game(){
		if (game_is_running)
			return;
		
		pitch = 0;
		enemy = new Point(600, 200);
		squid = new Point(900, 200);
		speed = 0;
		score = 0;
		life = 3;

		game_is_running = true;
		repaint();

	}

	
	
	
	
	
	
	
	
	
	
	
	int pitch;
	
	public double[] spectrum = new double[RESOLUTION];	
	public double[] prev_spectrum = new double[RESOLUTION];	
	
	  public void follow(){
   		
   		int n = voice.Voice.update();

		if (n==0)
			return;
		
		for(int i=0; i<4; i++){
			prev_spectrum = (double[]) spectrum.clone();
			voice.Voice.get_spectrum(spectrum, RESOLUTION, 1024-256-i*256);
			follow_sub();
		}
		
		game_tick();
		
		repaint();
		
	}
	
	public void follow_sub(){

		check_speaking();
		
		if (!speaking)
			return;
		
		
		double cor0 = calculate_corelation(-1);
		double cor2 = calculate_corelation(1);

		if (cor0 > cor2)
			pitch --;
		else
			pitch ++;
		
		if (pitch < MIN_PITCH)	pitch = MIN_PITCH;
		if (pitch > MAX_PITCH)	pitch = MAX_PITCH;
	}	
	public double calculate_corelation(int d){
		double cor = 0;
		for(int i=1; i<RESOLUTION/2-1; i++)
			cor+= spectrum[i+d] * prev_spectrum[i];
		
		return cor;
	}
	boolean speaking;
	public void check_speaking(){
		double total = 0;
		for(int i=3; i<RESOLUTION/2; i++){
			total += spectrum[i];
		}
		speaking = (total > 100);
	
	}	
	

	
 
   
	// central event dispatcher
	public class MouseDispatcher 
		extends MouseAdapter {

  		public void mouseClicked(MouseEvent e) {
	    	e.consume();
			start_game();
  		}
    }
	
}
